Unit QSG3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSG3R(var INT :Real; A :Real; B :Real; F :Func_F1);

implementation

procedure QSG3R(var INT :Real; A :Real; B :Real; F :Func_F1);
var
K :Integer;
D,E,G,H :Real;
C :Array [0..3] of Real;
C1 :Array [0..3] of Real;
label
_1;
begin
{   DATA  FORTRAN  }
C[0] := 0.4801449;
C[1] := 0.3983332;
C[2] := 0.2627662;
C[3] := 0.09171732;
C1[0] := 0.05061427;
C1[1] := 0.1111905;
C1[2] := 0.1568533;
C1[3] := 0.1813418;
H := 0.0;
D := 0.5*(A+B);
E := B-A;
for K:=1 to 4 do
 begin
  G := E*C[K-1];
  H := H+C1[K-1]*(F(D+G)+F(D-G));
_1:
 end;
INT := H*E;
end;

end.
